package com.tzld.piaoquan.ad.engine.server.controller;

import com.tzld.piaoquan.ad.engine.commons.param.RankRecommendRequestParam;
import com.tzld.piaoquan.ad.engine.commons.score.ScoreParam;
import com.tzld.piaoquan.ad.engine.service.log.LogHubService;
import com.tzld.piaoquan.ad.engine.service.predict.param.request.ThresholdPredictModelRequestParam;
import com.tzld.piaoquan.ad.engine.service.score.convert.RequestConvert;
import com.tzld.piaoquan.ad.engine.service.score.strategy.RankStrategy;
import com.tzld.piaoquan.ad.engine.service.score.strategy.RankStrategyBy688;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdRankItem;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/log")
public class LogUploadController {

    @Autowired
    private RankStrategyBy688 rankStrategyBy688;

    @Autowired
    private LogHubService logHubService;

    @RequestMapping("/coldStart")
    public Map<String, Object> coldLogUpload(@RequestBody RankRecommendRequestParam request) {
        ScoreParam scoreParam = RequestConvert.requestConvert(request);
        scoreParam.setColdStart(true);
        List<AdRankItem> adRankItems = rankStrategyBy688.adItemRank(request, scoreParam);
        logHubService.scoreLogUpload(scoreParam, request.getAdIdList(), adRankItems, request, scoreParam.getExpCode());
        return new HashMap<String, Object>() {{
            put("result", "success");
        }};
    }


}
